// *******************************************************************************************// SoundAndSpeech.c                                                        CLASSIC EVENT MODEL// *******************************************************************************************//// This program opens a modeless dialog containing five bevel button controls arranged in// two groups, namely, a synchronous sound group and an asynchronous sound group.  Clicking on// the bevel buttons causes sound to be played back or recorded as follows://// 	Synchronous group:////		  Play sound resource.////		  Record sound resource (Mac OS 8/9 only).////		  Speak text string.//// 	Asynchronous group:////		  Play sound resource.////		  Speak text string.//// The asynchronous sound sections of the program utilise a special library called// AsyncSoundLibPPC, which must be included in the CodeWarrior project.//// The program utilises the following resources://// 	A 'plst' resource.//// 	A 'DLOG' resource and associated 'DITL', 'dlgx', and 'dftb' resources (all purgeable).//// 	'CNTL' resources (purgeable) for the controls within the dialog.//// 	Two 'snd ' resources, one for synchronous playback (purgeable) and one for asynchronous//		playback (purgeable).//// 	Four 'cicn' resources (purgeable).  Two are used to provide an animated display which//		halts during synchronous playback and continues during asynchronous playback.  The//		remaining two are used by the bevel button controls.//// 	Two 'STR#' resources containing "speak text" strings and error message strings (all//		purgeable).//// 	'hrct' and 'hwin' resources (purgeable) for balloon help.//// 	A 'SIZE' resource with the acceptSuspendResumeEvents, canBackground, //		doesActivateOnFGSwitch, and isHighLevelEventAware flags set.//// Each time it is invoked, the function doRecordResource creates a new 'snd' resource with a// unique ID in the resource fork of a file titled "SoundResources".//// *******************************************************************************************//  includes#include <Carbon.h>#include <string.h>//  defines#define rDialog									128#define  iDone									1#define  iPlayResourceSync			4#define  iRecordResource				5#define  iSpeakTextSync					6#define  iPlayResourceASync			7	#define  iSpeakTextAsync				8#define rPlaySoundResourceSync	8192#define rPlaySoundResourceASync	8193#define rSpeechStrings					128#define rErrorStrings						129#define  eOpenDialogFail				1#define  eCannotInitialise			2#define  eGetResource						3#define  eMemory								4#define  eMakeFSSpec						5#define  eWriteResource					6#define  eNoChannelsAvailable		7#define  ePlaySound							8#define  eSndPlay								9		#define  eSndRecord							10#define  eSpeakString						11#define rColourIcon1						128#define rColourIcon2						129#define kMaxChannels						8#define kOutOfChannels					1//  global variablesBoolean		gRunningOnX = false;Boolean		gDone;DialogRef	gDialogRef;// .............................................................. AsyncSoundLib attention flagBoolean	gCallAS_CloseChannel = false;//  function prototypesvoid	main									(void);void	doPreliminaries				(void);OSErr	quitAppEventHandler		(AppleEvent *,AppleEvent *,SInt32);void	doInitialiseSoundLib	(void);void	eventLoop							(void);void	doDialogHit						(SInt16);void  doPlayResourceSync		(void);void	doRecordResource			(void);void	doSpeakStringSync			(void);void	doPlayResourceASync		(void);void	doSpeakStringAsync		(void);void	doSetUpDialog					(void);void	doErrorAlert					(SInt16);void	helpTags							(DialogRef);//  AsyncSoundLib function prototypesOSErr	AS_Initialise		(Boolean *,SInt16);OSErr	AS_GetChannel		(SInt32,SndChannelPtr *);OSErr	AS_PlayID				(SInt16, SInt32 *);OSErr	AS_PlayHandle		(Handle,SInt32 *);void	AS_CloseChannel	(void);void	AS_CloseDown		(void);// ************************************************************************************** mainvoid main(void){	SInt32	response;	//  do preliminaries	doPreliminaries();	//  disable Quit item in Mac OS X Application menu	DisableMenuCommand(NULL,'quit');	//  open and set up dialog	if(!(gDialogRef = GetNewDialog(rDialog,NULL,(WindowRef) -1)))	{		doErrorAlert(eOpenDialogFail);		ExitToShell();	}	SetPortDialogPort(gDialogRef);	SetDialogDefaultItem(gDialogRef,kStdOkItemIndex);	Gestalt(gestaltMenuMgrAttr,&response);	if(response & gestaltMenuMgrAquaLayoutMask)	{		helpTags(gDialogRef);		gRunningOnX = true;	}	doSetUpDialog();	ShowWindow(GetDialogWindow(gDialogRef));	//  initialise AsyncSoundLib	doInitialiseSoundLib();	//  enter event loop	eventLoop();}// *************************************************************************** doPreliminariesvoid  doPreliminaries(void){	OSErr	osError;	MoreMasterPointers(64);	InitCursor();	FlushEvents(everyEvent,0);	osError = AEInstallEventHandler(kCoreEventClass,kAEQuitApplication,														NewAEEventHandlerUPP((AEEventHandlerProcPtr) quitAppEventHandler),														0L,false);	if(osError != noErr)		ExitToShell();}// **************************************************************************** doQuitAppEventOSErr  quitAppEventHandler(AppleEvent *appEvent,AppleEvent *reply,SInt32 handlerRefcon){	OSErr			osError;	DescType	returnedType;	Size			actualSize;	osError = AEGetAttributePtr(appEvent,keyMissedKeywordAttr,typeWildCard,&returnedType,NULL,0,															&actualSize);	if(osError == errAEDescNotFound)	{		gDone = true;		osError = noErr;	} 	else if(osError == noErr)		osError = errAEParamMissed;	return osError;}// ********************************************************************** doInitialiseSoundLibvoid  doInitialiseSoundLib(void){	if(AS_Initialise(&gCallAS_CloseChannel,kMaxChannels) != noErr)	{		doErrorAlert(eCannotInitialise);		ExitToShell();	}}// ********************************************************************************* eventLoopvoid  eventLoop(void){	Rect				theRect, eraseRect;	CIconHandle	colourIconHdl1;	CIconHandle	colourIconHdl2;	SInt16			fontNum, itemHit;	UInt32 			finalTicks;	Boolean			gotEvent;	EventRecord	eventStructure;	DialogRef		theDialogRef;	WindowRef 	windowRef;	SInt16			partCode;	SetRect(&theRect,262,169,294,201);	SetRect(&eraseRect,310,170,481,200);	colourIconHdl1 = GetCIcon(rColourIcon1);	colourIconHdl2 = GetCIcon(rColourIcon2);	gDone = false;	while(!gDone) 	{		if(gCallAS_CloseChannel)		{			AS_CloseChannel();			GetFNum("\pGeneva",&fontNum);			TextFont(fontNum);			TextSize(10);			MoveTo(341,189);			DrawString("\pAS_CloseChannel called");			QDFlushPortBuffer(GetWindowPort(FrontWindow()),NULL);			Delay(45,&finalTicks);		}		gotEvent = WaitNextEvent(everyEvent,&eventStructure,10,NULL);		if(gotEvent)		{			if(IsDialogEvent(&eventStructure))			{				if(DialogSelect(&eventStructure,&theDialogRef,&itemHit))					doDialogHit(itemHit);			}			else			{				if(eventStructure.what == mouseDown)				{					partCode = FindWindow(eventStructure.where,&windowRef);					if(partCode == inDrag)						DragWindow(windowRef,eventStructure.where,NULL);					if(partCode == inMenuBar)						MenuSelect(eventStructure.where);				}			}		}		else		{			PlotCIcon(&theRect,colourIconHdl1);			QDFlushPortBuffer(GetDialogPort(gDialogRef),NULL);			Delay(5,&finalTicks);			PlotCIcon(&theRect,colourIconHdl2);			Delay(5,&finalTicks);			EraseRect(&eraseRect);		}	}	DisposeDialog(gDialogRef);	AS_CloseDown();}// ******************************************************************************* doDialogHitvoid  doDialogHit(SInt16 item){	switch(item) 	{		case iDone:			gDone = true;			break;		case iPlayResourceSync:			doPlayResourceSync();			break;		case iRecordResource:			doRecordResource();			break;		case iSpeakTextSync:			doSpeakStringSync();			break;		case iPlayResourceASync:			doPlayResourceASync();			break;		case iSpeakTextAsync:			doSpeakStringAsync();			break;	}}// ************************************************************************ doPlayResourceSyncvoid  doPlayResourceSync(void){	SndListHandle	sndListHdl;	SInt16				resErr;	OSErr					osErr;	ControlRef		controlRef;	sndListHdl = (SndListHandle) GetResource('snd ',rPlaySoundResourceSync);	resErr = ResError();	if(resErr != noErr)		doErrorAlert(eGetResource);	if(sndListHdl != NULL)	{		HLock((Handle) sndListHdl);		osErr = SndPlay(NULL,sndListHdl,false);		if(osErr != noErr)			doErrorAlert(eSndPlay);		HUnlock((Handle) sndListHdl);		ReleaseResource((Handle) sndListHdl);		GetDialogItemAsControl(gDialogRef,iPlayResourceSync,&controlRef);		SetControlValue(controlRef,0);	}}// ************************************************************************** doRecordResourcevoid  doRecordResource(void){	SInt16			oldResFileRefNum, theResourceID, resErr, tempResFileRefNum;	BitMap			screenBits;	Point				topLeft;	OSErr				memErr, osErr;	Handle			soundHdl;	FSSpec			fileSpecTemp;	ControlRef	controlRef;	oldResFileRefNum = CurResFile();	GetQDGlobalsScreenBits(&screenBits);	topLeft.h = (screenBits.bounds.right / 2) - 156;	topLeft.v = 150;		soundHdl = NewHandle(25000);	memErr = MemError();	if(memErr != noErr)	{		doErrorAlert(eMemory);		return;	}	osErr = FSMakeFSSpec(0,0,"\pSoundResources",&fileSpecTemp);	if(osErr == noErr)	{		tempResFileRefNum = FSpOpenResFile(&fileSpecTemp,fsWrPerm);		UseResFile(tempResFileRefNum);	}	else		doErrorAlert(eMakeFSSpec);	if(osErr == noErr)	{		osErr = SndRecord(NULL,topLeft,siBetterQuality,&(SndListHandle) soundHdl);		if(osErr != noErr && osErr != userCanceledErr)			doErrorAlert(eSndRecord);		else if(osErr != userCanceledErr)		{			do			{				theResourceID = UniqueID('snd ');			} while(theResourceID <= 8191 && theResourceID >= 0);			AddResource(soundHdl,'snd ',theResourceID,"\pTest");			resErr = ResError();			if(resErr == noErr)				UpdateResFile(tempResFileRefNum);			resErr = ResError();			if(resErr != noErr)				doErrorAlert(eWriteResource);		}				CloseResFile(tempResFileRefNum);	}	DisposeHandle(soundHdl);	UseResFile(oldResFileRefNum);	GetDialogItemAsControl(gDialogRef,iRecordResource,&controlRef);	SetControlValue(controlRef,0);}// ************************************************************************* doSpeakStringSyncvoid  doSpeakStringSync(void){	SInt16			activeChannels;	Str255			theString;	OSErr				resErr, osErr;	ControlRef	controlRef;	activeChannels = SpeechBusy();	GetIndString(theString,rSpeechStrings,1);	resErr = ResError();	if(resErr != noErr)	{		doErrorAlert(eGetResource);		return;	}	osErr = SpeakString(theString);	if(osErr != noErr)		doErrorAlert(eSpeakString);	while(SpeechBusy() != activeChannels)		;	GetDialogItemAsControl(gDialogRef,iSpeakTextSync,&controlRef);	SetControlValue(controlRef,0);}// *********************************************************************** doPlayResourceASyncvoid  doPlayResourceASync(void){	SInt16	error;	error = AS_PlayID(rPlaySoundResourceASync,NULL);	if(error == kOutOfChannels)		doErrorAlert(eNoChannelsAvailable);	else		if(error != noErr)			doErrorAlert(ePlaySound);}// ************************************************************************ doSpeakStringAsyncvoid  doSpeakStringAsync(void){	Str255	theString;	OSErr		resErr, osErr;	GetIndString(theString,rSpeechStrings,2);	resErr = ResError();	if(resErr != noErr)	{		doErrorAlert(eGetResource);		return;	}	osErr = SpeakString(theString);	if(osErr != noErr)		doErrorAlert(eSpeakString);}// ***************************************************************************** doSetUpDialogvoid  doSetUpDialog(void){	SInt16												a;	Point													offset;	ControlRef										controlRef;	ControlButtonGraphicAlignment	alignConstant = kControlBevelButtonAlignLeft;	ControlButtonTextPlacement		placeConstant = kControlBevelButtonPlaceToRightOfGraphic;	offset.v = 1;	offset.h = 5;	for(a=iPlayResourceSync;a<iSpeakTextAsync+1;a++)	{		GetDialogItemAsControl(gDialogRef,a,&controlRef);		SetControlData(controlRef,kControlEntireControl,kControlBevelButtonGraphicAlignTag,									 sizeof(alignConstant),&alignConstant);		SetControlData(controlRef,kControlEntireControl,kControlBevelButtonGraphicOffsetTag,									 sizeof(offset),&offset);		SetControlData(controlRef,kControlEntireControl,kControlBevelButtonTextPlaceTag,									sizeof(placeConstant),&placeConstant);	}	if(gRunningOnX)	{		GetDialogItemAsControl(gDialogRef,iRecordResource,&controlRef);		DeactivateControl(controlRef);	}}// ****************************************************************************** doErrorAlertvoid  doErrorAlert(SInt16 errorStringIndex){	Str255	errorString;	SInt16	itemHit;	GetIndString(errorString,rErrorStrings,errorStringIndex);	StandardAlert(kAlertCautionAlert,errorString,NULL,NULL,&itemHit);}// ********************************************************************************** helpTagsvoid  helpTags(DialogRef dialogRef){	HMHelpContentRec	helpContent;	SInt16						a;	ControlRef				controlRef;  memset(&helpContent,0,sizeof(helpContent));  HMSetTagDelay(500);  HMSetHelpTagsDisplayed(true);	helpContent.version = kMacHelpVersion;	helpContent.tagSide = kHMOutsideTopCenterAligned;	helpContent.content[kHMMinimumContentIndex].contentType = kHMStringResContent;	helpContent.content[kHMMinimumContentIndex].u.tagStringRes.hmmResID = 130;	for(a = 1;a <= 5; a++)	{		if(a == 2)			continue;		helpContent.content[kHMMinimumContentIndex].u.tagStringRes.hmmIndex = a;		GetDialogItemAsControl(dialogRef,a + 3,&controlRef);		HMSetControlHelpContent(controlRef,&helpContent);	}}// *******************************************************************************************